package com.ruoyi.project.business.service;

import com.baomidou.mybatisplus.extension.service.IService;
import com.ruoyi.common.importExcel.excel.helper.BasicExcelHelper;
import com.ruoyi.common.importExcel.excel.helper.BasicTableInfoHelper;
import com.ruoyi.common.importExcel.excel.helper.PriceFormTableInfoHelper;
import com.ruoyi.common.importExcel.excel.tempInfo.ParaValidationInfoHelper;
import com.ruoyi.common.importExcel.excel.tempInfo.PriceFormBasicInfoHelper;
import com.ruoyi.common.importExcel.utils.ExcelUtils;
import com.ruoyi.project.business.domain.TpParaValidation;
import com.ruoyi.project.business.domain.TpParaValidationElevator;
import com.ruoyi.project.business.domain.bo.validation.ComputeQueryBO;
import com.ruoyi.project.business.domain.bo.validation.ElevatorQueryBO;
import com.ruoyi.project.business.domain.vo.validataion.ComputeResultVO;
import com.ruoyi.project.business.domain.vo.validataion.ParamCheckResultVO;
import com.ruoyi.project.business.dto.TpParaValidationDto;

import java.util.Collection;
import java.util.Date;
import java.util.List;

/**
 * 校验规则配置Service接口
 *
 * @author ruoyi
 * @date 2024-04-29
 */
public interface ITpParaValidationService extends IService<TpParaValidation> {
    /**
     * 查询校验规则配置
     *
     * @param id 校验规则配置主键
     * @return 校验规则配置
     */
    TpParaValidation selectTpParaValidationById(Long id);

    /**
     * 查询校验规则配置列表
     *
     * @param tpParaValidation 校验规则配置
     * @return 校验规则配置集合
     */
    List<TpParaValidation> selectTpParaValidationList(TpParaValidation tpParaValidation);

    /**
     * 新增校验规则配置
     *
     * @param tpParaValidation 校验规则配置
     * @return 结果
     */
    int insertTpParaValidation(TpParaValidation tpParaValidation);

    /**
     * 修改校验规则配置
     *
     * @param tpParaValidation 校验规则配置
     * @return 结果
     */
    int updateTpParaValidation(TpParaValidation tpParaValidation);

    /**
     * 批量删除校验规则配置
     *
     * @param ids 需要删除的校验规则配置主键集合
     * @return 结果
     */
    int deleteTpParaValidationByIds(Long[] ids);

    /**
     * 删除校验规则配置信息
     *
     * @param id 校验规则配置主键
     * @return 结果
     */
    int deleteTpParaValidationById(Long id);

    List<TpParaValidationDto> getTableList(TpParaValidationDto param);

    int saveOrUpdate(TpParaValidationDto param);

    TpParaValidationDto getInfoById(Long id);

    int deleteById(Long id, Date updateTime);

    int changeStatus(TpParaValidationDto param);

    List<ParamCheckResultVO> checkElevatorParam(ElevatorQueryBO queryBO);

    ComputeResultVO computeElevatorParam(ComputeQueryBO queryBO);
    List<? extends List<? extends BasicExcelHelper>> getParaValidationList();

    ExcelUtils.UploadResult<ParaValidationInfoHelper> checkParaValidation(BasicTableInfoHelper tableInfoHelper,
                                                                          List<ParaValidationInfoHelper> paraValidationInfoHelpers);

    List<String> insertParaValidation(BasicTableInfoHelper basicTableInfoHelper, List<ParaValidationInfoHelper> transform);


}
